/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 * ----------------------------------------------------------
 * In this file methods to access the soundcard are provided.
 * ----------------------------------------------------------
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/


function Audiosystem()
{
   var player;

   var audiocontext = null;
   var t=0;
   //var sample_rate // siehe Paramter.js
   //var dt // siehe Parameter.js

   var READY = false;

   var instrument = null;
   this.isReady = function()
   {
       return READY;
   }

   function iabs(x)
   {
    if(x<0)
        return -x;
    else
        return x;
   }

   function midi2Frequency(midi)
   {
        if(midi<1.0)
            return 0.0; //Nullereignisse behandeln
  
        var freq69 = Math.pow(2.0,69.0/12.0);
        return Math.pow(2.0,midi/12.0)*440.0/freq69;
   }

var ZEIT=0;
   function prozess(e)   
   {
             /*
                       var zNeu = new Date();
                       if(player && zNeu>=ZEIT+player.getPauseMs())
                       {
                           ZEIT = zNeu;
                           player.run();
                       }
             */
    var data_left  = e.outputBuffer.getChannelData(0);
    var data_right = e.outputBuffer.getChannelData(1);
    
    for(var k=0;k<data_left.length;k++)
    {

        var tt = Math.floor(t*1000.0);   
 
        var ton2=0;
        var LEFT=0;
        var RIGHT=0;
        if(instrument!=null)
        {
            instrument[0].step();
            LEFT = instrument[0].getLEFT();
            RIGHT = instrument[0].getRIGHT();
            instrument[1].step();
            LEFT += instrument[1].getLEFT();
            RIGHT += instrument[1].getRIGHT();
            //instrument[2].step();
            //LEFT += instrument[2].getLEFT();
            //RIGHT += instrument[2].getRIGHT();
        }
        data_left[k]=AMPLITUDE*LEFT;
        data_right[k]=AMPLITUDE*RIGHT;

        t+=dt;
    }
   }

   function initialisiereAudiokontext()
   {
//       audiocontext = new (window.AudioContext || window.webkitAudioContext)();
//       audiocontext = new (window.AudioContext)();
//audiocontext = new (AudioContext || webkitAudioContext)({sampleRate: 22050,});
audiocontext = new (AudioContext || webkitAudioContext)({sampleRate: sample_rate,});
//       audiocontext = new (window.webkitAudioContext)();
//alert("sample_rate = "+audiocontext.sampleRate);
sample_rate = audiocontext.sampleRate; //Parameter.js
dt = 1.0/sample_rate;
       //1. Param.: Erlaubte Puffergroessen: 256, 512, 1024, 2048, 4096, 8192, 16384
       //2. Param.: Anzahl der Input-Kanaele
       //3. Param.: Anzahl der Output-Kanaele
//       node = audiocontext.createScriptProcessor(1024, 0, 2);
       node = audiocontext.createScriptProcessor(buffer_size, 0, 2);
       node.onaudioprocess = function(e) { prozess(e) };
       node.connect(audiocontext.destination); //"play"

   }

   this.addInstrument = function(xinstrument)
   {
      instrument = xinstrument;
   }

   this.registerPlayer = function(xplayer)
   {
        player = xplayer;
   }

   this.init = function(xplayer)
   {
      oberton = new Oberton();
      oberton.init(dt,440,0.004,1.0); //Dt,Freq,Q,Amp
      

      //alert(SAMP.length+" "+SAMP[0].length+" "+SAMP[1].length);
      initialisiereAudiokontext();        
      READY = true;
   }
}
