/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 * ---------------------------------------------------------------------------------------------------------
 * Bild is a german word and it means image
 *
 * This file provides an editor to add or remove  spheres in a 3D space.
 * 
 * ---------------------------------------------------------------------------------------------------------
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/

function Editor()
{
     var szene;
     var RASTERKANTE;
     var xoff,yoff,width,height,dx,dy;
     var szeneS;
     this.init =  function(iszene,ixoff,iyoff,iwidth,iheight)
     {
         xoff = ixoff;
         yoff = iyoff;
         width = iwidth;
         height = iheight;
         szene = iszene;
         szeneS = szene.getS();
         //alert("szeneS.length="+szeneS.length+" szeneS[0].length"+szeneS[0].length+" szeneS[0][0].length"+szeneS[0][0].length);
         RASTERKANTE = szeneS.length;
         dy = height/(RASTERKANTE*RASTERKANTE);
         dx = width/RASTERKANTE;
     }
     
     this.getWidth = function()
     {
         return width;
     }

     this.drawSzene = function(qapplet)
     {
         
         qapplet.fill(210);
         qapplet.rect(xoff,yoff,width,height);
         for(var y=0;y<RASTERKANTE;y++) //jede Schicht/Ebene ist ein quadratisches Spielfeld
         {
             //float yy = yoff+(float)y*(float)RASTERKANTE*dy;
             //Darstellung rückwärts, sond nicht passend zu Szene links:
             var yy = yoff + height - (y+1)*RASTERKANTE*dy;
             var xx = xoff;

             
             qapplet.stroke(90);
             qapplet.strokeWeight(4);
             qapplet.noFill();
             for(var z=0;z<RASTERKANTE;z++)
             {
                 for(var x=0;x<RASTERKANTE;x++)
                 {
                     qapplet.rect(xx+x*dx,yy+z*dy,dx,dy);
                 }
             }
             qapplet.stroke(100);    
             qapplet.strokeWeight(8);
             qapplet.rect(xx,yy,dx*RASTERKANTE,dy*RASTERKANTE);

  
         }
         
         var pinx = php.getParamIndex();
         if(pinx<=124)
         {
             qapplet.stroke(255,0,0);
             qapplet.strokeWeight(4);
             qapplet.noFill();
           var iiiii = Math.floor(pinx/25);
           var kkkkk = Math.floor(pinx/5)%5;
           var qqqqq = pinx%5;
           var zzzzz = 5-1-kkkkk;
           var yyyyy = 5-1-iiiii;
           var xxxxx = qqqqq;
           var kyy = yoff + height - (yyyyy+1)*RASTERKANTE*dy;
           var kxx = xoff;
           var kkxx = kxx+xxxxx*dx;
           var kkyy = kyy+zzzzz*dy;
           qapplet.rect(kkxx,kkyy,dx,dy);
         }
         

         //Kugeln:
         for(var y=0;y<RASTERKANTE;y++) //jede Schicht/Ebene ist ein quadratisches Spielfeld
         {
             //float yy = yoff+(float)y*(float)RASTERKANTE*dy;
             //Darstellung rückwärts, sond nicht passend zu Szene links:
             var yy = yoff + height - (y+1)*RASTERKANTE*dy;
             var xx = xoff;
             
             qapplet.noStroke();
             qapplet.strokeWeight(1);

             for(var z=0;z<RASTERKANTE;z++)
             {
                 for(var x=0;x<RASTERKANTE;x++)
                 {
                     if(szeneS[z][y][x]>0)
                     {
                          var c = szeneS[z][y][x];
                          //qapplet.fillIndex(c);
                          qapplet.fill(COLOR[c][0],COLOR[c][1],COLOR[c][2]);

                          //ellipse(xx+(float)x*dx+0.5f*dx,yy+(float)z*dy+0.5f*dy,dx,dy);
                          //auch z umkehren, damit passend:
                          qapplet.ellipse(xx+x*dx+0.5*dx,yy+RASTERKANTE*dy-(z+1)*dy+0.5*dy,dx*0.8,dy*0.8);
                     }
                 }
             }  
  
         }

      
     }
     
     this.mousePressed = function(mouseX,mouseY)
     {
         if(mouseX>xoff && mouseX<xoff+width && mouseY>yoff && mouseY<yoff+height)
         {
              var xx = Math.floor(mouseX-xoff);
              var yy = Math.floor(mouseY-yoff);
              
              var x = Math.floor(xx/dx);
              var q = Math.floor(yy/dy);
              
              var z = Math.floor( RASTERKANTE -1 -q%RASTERKANTE );
              var y = Math.floor( RASTERKANTE -1 -Math.floor(q/RASTERKANTE) );
              
              //if(qapplet.height)
              if(useSELECT==true)
              {
                  if(szeneS[z][y][x]!=SELECTED)
                  {
                      //vergl. PHP.js
                      var uuu = 5-1-z;
                      var vvv = 5-1-y;
                      var www = x;

                      var cindex = vvv*25 + uuu*5 + www;
                      CHANGED[cindex]=SERVERTIME;

                      szeneS[z][y][x] = SELECTED;
                  }
                  else
                  {
                      szeneS[z][y][x] = 0;
                  }
              }
              else
              {
                      //vergl. PHP.js
                      var uuu = 5-1-z;
                      var vvv = 5-1-y;
                      var www = x;

                      var cindex = vvv*25 + uuu*5 + www;
                      CHANGED[cindex]=SERVERTIME;
                  szeneS[z][y][x] = szeneS[z][y][x] +1;
                  szeneS[z][y][x] = szeneS[z][y][x]%(COLOR.length);
              }
         }
     }

     //COLOR SELECTION
     var SELECTED = 1;

     this.mousePressedSelect = function(mouseX,mouseY,ixoff,iyoff,iwidth,iheight)
     {
         if(mouseX>width && mouseX<width+iwidth && mouseY>yoff && mouseY<yoff+height)
         {
             var dx = iwidth / COLINX.length;
             SELECTED = Math.floor((mouseX - width)/ dx);
         }
     }

     this.drawSelectableColors = function(qapplet,xoff,yoff,width,height)
     {
         var dx = width / COLINX.length;
         for(var i=0;i<COLINX.length;i++)
         {
             qapplet.fillIndex(i);
             qapplet.noStroke();
             qapplet.rect(xoff+i*dx,yoff,dx,height);
         }
         qapplet.strokeWeight(4);
         qapplet.stroke(255,255,255);
         qapplet.noFill();
         qapplet.rect(xoff+SELECTED*dx,yoff,dx,height);
     }
    
          
}

