/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 * ---------------------------------------------------------------------------------
 * This file provides helpful methods which are used by other parts of this project.
 * ---------------------------------------------------------------------------------
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/

    function makeArrayZerosZerosZerosZeros(zeilen, spalten, tiefe, ups)
    {
         var arr = new Array(zeilen);
         for(var i=0;i<arr.length;i++)
         {
               arr[i] = new Array(spalten);
               for(var k=0;k<arr[i].length;k++)
               {
                    arr[i][k] = new Array(tiefe);
                    for(var q=0;q<arr[i][k].length;q++)
                    {
                        arr[i][k][q] = new Array(ups);
                        for(var p=0;p<arr[i][k][q].length;p++)
                            arr[i][k][q][p]=0;
                    }
               }
         }
         return arr;
    }
    

    function makeArrayZerosZerosZeros(zeilen, spalten, tiefe)
    {
         var arr = new Array(zeilen);
         for(var i=0;i<arr.length;i++)
         {
               arr[i] = new Array(spalten);
               for(var k=0;k<arr[i].length;k++)
               {
                    arr[i][k] = new Array(tiefe);
                    for(var q=0;q<arr[i][k].length;q++)
                        arr[i][k][q] = 0;
               }
         }
         return arr;
    }
    
    
    function makeArrayZerosZeros(zeilen, spalten)
    {
         var arr = new Array(zeilen);
         for(var i=0;i<arr.length;i++)
         {
               arr[i] = new Array(spalten);
         }
         for(var i=0;i<arr.length;i++)
            for(var k=0;k<arr[i].length;k++)
                arr[i][k] = 0;


         return arr;
    }



    function makeZeros(zeilen)
    {
         var arr = new Array(zeilen);
         for(var i=0;i<arr.length;i++)
         {
               arr[i] = 0;
         }
         return arr;
    }




      /**
       * @param array integer array with values. Its indices shall be sorted by this method.
       * @param used_in_array Only the first n=used_in_array are used in the passed array.
       * @param Writes into reference idices the indices of the values of the passed array starting with the biggest one.
       * 
       */
      function sortIndicesBiggestFirst(array, used_in_array, indices)
      {
            for(var i=0;i<used_in_array;i++)
            {
                 var biggest = -999999999.9;
                 
                 for(var k=0;k<used_in_array;k++)
                 {
                      var in_use = false;
                      for(var p=0;p<i;p++)
                      {
                          if(k==indices[p])
                          {
                               in_use = true;
                               break;
                          }
                      }    
                      
                      if(in_use==false && array[k]>=biggest)
                      {
                            biggest = array[k];
                            indices[i] = k;
                      }
                 }
            }
      } 


     function midi2Frequency(midi)
     {
        if(midi<1.0)
            return 0.0; //Nullereignisse behandeln
  
        var freq69 = Math.pow(2.0,69.0/12.0);
        return Math.pow(2.0,midi/12.0)*440.0/freq69;
     }

     function frequency2Midi(freq)
     {
        if(freq<1.0)
             return 0.0; //Nullereignisse behandeln
  
        var freq69 = Math.pow(2.0,69.0/12.0);
        return 12.0*Math.log(freq*freq69/440.0)/Math.log(2.0);
     }

     function freq2mid(freq)
     {
       if(freq==0)
           return 0;
       else
           return Math.round(frequency2Midi(freq));
     }

     function mid2freq(mid)
     {
         if(mid==0)
             return 0;
         else
             return Math.round(midi2Frequency(mid));
     }            

     function iabs(x)
     {
          if(x<0.0)
              return -x;
          else
              return x;
     }

    
     function double2int(x)
     {
         x = x*1000.0;
         x = Math.round(x);
         return x;
     }

     function int2double(x)
     {
         x = x/1000.0;
         return x;
     }



    function zerlegenZiel(ziel,x,trenner)
    {
        if(x==null || x.length==0)
            return;

        var u=0;
        var tt="";
        for(var i=0;i<x.length;i++)
        {
            var c = x.charAt(i);
            if(c==trenner)
            {
               ziel[u]=tt;
               tt="";
               u++;
            }
            else
            {
               tt+=""+c;
            }
        }
    }

