/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 * ------------------------------------------------------------
 * In this file the most important parameters are put together.
 * ------------------------------------------------------------
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/
   const socket = new WebSocket('ws://localhost:8025/midi');

   var MUTE = false;

   var SECOND_VOICE_8va_BASSA = false;

   var t_AKTUELL = 0;

   var KOLLABORATE_WITH_OTHERS = true; //if false: sync with web is blocked


   var ALLENAMEN = new Array();

   var MULTIPLY_BASE_WITH_AREA_COUNT = false;

   var BEATS_PER_MINUTE_PER_TICK = 132;

   var ACTIVEUSER = null; // Rangfolge der aktiven Benutzer (erste 5)
   var hACTIVEUSER = null; //copy  Rangfolge der aktiven Benutzer (erste 5)

   var SERVERDATA = null; // value, timestamp, usersessionnumber, nickname

   var SERVERTIME = 0;

   var CHANGED = [0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0,0,
                  0,0,0,0,0, 0,0,0,0
                 ];

   var php; //!!!!!!!!!!!! global, so call von form aus möglich!!!


    var EMPFANGEN = "";

// Nickname kommt vom Eingabefeld
    var NICKNAME = "anonymous";

// parameter connected to the server
    var TIME = 0;

// nur ein Test!:
    var TESTWERT = 0; //vergl. draw und PHP

//    var SESSION_ID = "id" + Math.random().toString(36).substr(2, 12);
//    var USER_ID = "user_id_" + Math.floor(Math.random()*1000000000000000.0);
    var USER_ID = Math.floor(Math.random()*1000000000000000.0);

    var KALEIDOSCOPICVIEW = false;

    var LOGGING = false;

    // color-codes
    var COLOR = [
        [0,0,0],     // 0 black
        [0,0,255],   // 1 blue    represents the prime number 2
        [255,0,0],   // 2 red     represents the prime number 3   
        [0,255,0],   // 3 green   represents the prime number 5
        [255,255,0], // 4 yellow  represents the prime number 7
        [127,127,127],// 5 grey    multiple grey fields represent an operator
        [31,31,31]];    // 6 black to hide things, bei Segmentierung: alle Indices AUSSER 6 als Farbe zusammenfassen!
//Der Einfachheit den Index 6 wenn er auftaucht VOR der Segmentierung in Index 0 verwandeln

    var COLINX = [ // für JS optimiert
        "#000000",   // 0 black
        "#0000ff",   // 1 blue    represents the prime number 2
        "#ff0000",   // 2 red     represents the prime number 3   
        "#00ff00",   // 3 green   represents the prime number 5
        "#ffff00",   // 4 yellow  represents the prime number 7
        "#7f7f7f",   // 5 grey    multiple grey fields represent an operator
        "#1f1f1f"];    // 6 black to hide things, bei Segmentierung: alle Indices AUSSER 6 als Farbe zusammenfassen!
//Der Einfachheit den Index 6 wenn er auftaucht VOR der Segmentierung in Index 0 verwandeln

//mit alfa:

    var COLINXA1 = [ // für JS optimiert
        "#000000ff",   // 0 black
        "#0000ffff",   // 1 blue    represents the prime number 2
        "#ff0000ff",   // 2 red     represents the prime number 3   
        "#00ff00ff",   // 3 green   represents the prime number 5
        "#ffff00ff",   // 4 yellow  represents the prime number 7
        "#7f7f7fff",   // 5 grey    multiple grey fields represent an operator
        "#1f1f1fff"];    // 6 black to hide things, bei Segmentierung: alle Indices AUSSER 6 als Farbe zusammenfassen!

    var COLINXA2 = [ // für JS optimiert
        "#00000080",   // 0 black
        "#0000ff80",   // 1 blue    represents the prime number 2
        "#ff000080",   // 2 red     represents the prime number 3   
        "#00ff0080",   // 3 green   represents the prime number 5
        "#ffff0080",   // 4 yellow  represents the prime number 7
        "#7f7f7f80",   // 5 grey    multiple grey fields represent an operator
        "#1f1f1f80"];    // 6 black to hide things, bei Segmentierung: alle Indices AUSSER 6 als Farbe zusammenfassen!

    var COLINXA3 = [ // für JS optimiert
        "#00000040",   // 0 black
        "#0000ff40",   // 1 blue    represents the prime number 2
        "#ff000040",   // 2 red     represents the prime number 3   
        "#00ff0040",   // 3 green   represents the prime number 5
        "#ffff0040",   // 4 yellow  represents the prime number 7
        "#7f7f7f40",   // 5 grey    multiple grey fields represent an operator
        "#1f1f1f40"];    // 6 black to hide things, bei Segmentierung: alle Indices AUSSER 6 als Farbe zusammenfassen!


    
var KANTE = 200;
var dPIXEL = 1;
var dKANTE = dPIXEL*KANTE; //skalierte Darstellung

var MINDEST_PIXEL_PRO_FELD = 5; //siehe 154 in Segmentierung.js
var MIN_SELECT_HEIGHT = 25;
var useSELECT = false;
var WIDTHEDITOR = 0;

//var sample_rate = 96000;
//var sample_rate = 48000;
//var sample_rate = 44100;
var sample_rate = 44100;
var buffer_size = 8192;
//var sample_rate = 22050;
var dt = 1.0/sample_rate;

var AMPLITUDE = 0.03;

var DRAW = true;

var vibDAMP = 1.0;
var marDAMP = 1.0;
var midishift = 0;

//NEU für wave
var WAVE_VELOCITY = new Array(0.6,0.6);

//Wavetables als globale Parameter:
var WAVESAMPLE = new Array(2); //für zwei Instrumente!, see Wave.js and Main.js QApplet.init() 
var MINENERGY = 1000.0; // see Wave
var MAXPOLY = 100;

var PHYSMOD = true;

//var FORMS = "";


var FORMS="<form onsubmit=\'return false\' style=\'width:0px; height:0px; visibility:hidden;\' id=\'systemtime\' method=\'POST\' target=\'systemtimeiframe\' action=\'zsystemtime.php\'>"+
"</form>"+
"<iframe style=\'width:0px; height:0px; visibility:hidden;\' id=\'systemtimeiframe\' name=\'systemtimeiframe\' src=\'zsystemtime.php\'>"+
"<html><head><meta charset=\'utf-8\'></head><body>0</body></html>"+
"</iframe>"+

"<form onsubmit=\'return false\' style=\'width:0px; height:0px; visibility:hidden;\' id=\'holewert\' method=\'POST\' target=\'holewertiframe\' action=\'zholewert.php\'>"+
"    <input id=\'nummer\' name=\'nummer\' value=\'0\'/>"+
"    <input id=\'ywert\' name=\'ywert\' value=\'0\'/>"+
"    <input id=\'ysessionid\' name=\'ysessionid\' value=\'0\'/>"+
"    <input id=\'ynickname\' name=\'ynickname\' value=\'anonymous\'/>"+
"    <input id=\'ychanged\' name=\'ychanged\' value=\'0\'/>"+
"</form>"+
"<iframe style=\'width:0px; height:0px; visibility:hidden;\' id=\'holewertiframe\' name=\'holewertiframe\' src=\'zholewert.php\'>"+
"<html><head><meta charset=\'utf-8\'></head><body>0</body></html>"+
"</iframe>"+

"<form onsubmit=\'return false\' style=\'width:0px; height:0px; visibility:hidden;\' id=\'xspeicherwert\' method=\'POST\' target=\'xspeicherwertiframe\' action=\'zspeicherwert.php\'>"+
"    <input id=\'xnummer\' name=\'xnummer\' value=\'0\'/>"+
"    <input id=\'xwert\' name=\'xwert\' value=\'0\'/>"+
"    <input id=\'xsessionid\' name=\'xsessionid\' value=\'0\'/>"+
"    <input id=\'xnickname\' name=\'xnickname\' value=\'anonymous\'/>"+
"    <input id=\'xchanged\' name=\'xchanged\' value=\'0\'/>"+
"</form>"+
"<iframe  style=\'width:0px; height:0px; visibility:hidden;\'  id=\'xspeicherwertiframe\' name=\'xspeicherwertiframe\' src=\'zspeicherwert.php\'>"+
"<html><head><meta charset=\'utf-8\'></head><body>0</body></html>"+
"</iframe>"+


"<form onsubmit=\'return false\' style=\'width:0px; height:0px; visibility:hidden;\' id=\'xspeichername\' method=\'POST\' target=\'xspeichernameiframe\' action=\'zspeichername.php\'>"+
"    <input id=\'xxsessionid\' name=\'xxsessionid\' value=\'0\'/>"+
"    <input id=\'xxnickname\' name=\'xxnickname\' value=\'anonymous\'/>"+
"</form>"+
"<iframe  style=\'width:0px; height:0px; visibility:hidden;\'  id=\'xspeichernameiframe\' name=\'xspeichernameiframe\' src=\'zspeichername.php\'>"+
"<html><head><meta charset=\'utf-8\'></head><body>0</body></html>"+
"</iframe>"+

"<form onsubmit=\'return false\' style=\'width:0px; height:0px; visibility:hidden;\' id=\'xholenamen\' method=\'POST\' target=\'xholenameniframe\' action=\'zholenamen.php\'>"+
"</form>"+
"<iframe  style=\'width:0px; height:0px; visibility:hidden;\'  id=\'xholenameniframe\' name=\'xholenameniframe\' src=\'zholenamen.php\'>"+
"<html><head><meta charset=\'utf-8\'></head><body>0</body></html>"+
"</iframe>";







