/**
 * Copyright (c) 2021 Guido Kramann
 *
 * This file is part of a project called kaleidophone - http://www.kramann.info/kaleidophone
 *
 * ------------------------------------------------------------
 * This file is responsible to play tones in a specific tempo.
 * Tone events appear in Segmentierung.js and are played.
 * ------------------------------------------------------------
 *
 * kaleidophone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * kaleidophone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the kaleidophone. If not, see <http://www.gnu.org/licenses/>.
*/


function Player()
{
    /*
    Dummy-Player

    liefert in MIDI Miditöne zu jedem Tick.
    Etabliert Prozess
    
    */

    var MIDI = ["",""];

    var BPM;
    var pause_ms;
    var t0;
    var t;
    var tick;

    var segmentierung;

    var process;

    var instrument;

    this.getMidi = function(i)
    {
        return MIDI[i];
    }

    this.getPauseMs = function()
    {
        return pause_ms;
    }

    this.getT = function()
    {
        return t;
    }

    this.init = function(it0,isegmentierung,xinstrument)
    {
        t0 = it0;
        t  = t0;
        tick = 0;
        segmentierung = isegmentierung; //Array!
        instrument = xinstrument;
    }

    function startProcess()
    {
        //process = setInterval(run, pause_ms); 
    }
    this.startProcess = function() {startProcess();}


    function stopProcess()
    {
        //clearInterval(process);        
    }
    this.stopProcess = function() {stopProcess();}


    function setBPM(iBPM)  //Startet auch Thread!!!!
    {
        BPM = iBPM;
        pause_ms = Math.round((60000.0/BPM)/4.0);  // von 4tel auf 16tel, deshalb/4
        //if(process)
        //    clearInterval(process);      
        //process = setInterval(run, pause_ms); 
run();
    }
    this.setBPM = function(iBPM) {setBPM(iBPM);}

    function run()
    {
            var ZEIT = Date.now();
            //var B       = 2*2*2520;
            //var FACTOR  = 0.5;
            
            t_AKTUELL = t+t_ZERO;

            MIDI[0] = segmentierung[0].evaluateFormel(false,t+t_ZERO,BASENUMBER,FACTOR,instrument[0].getMidimin(),instrument[0].getMidimax(),instrument[0]);
            MIDI[1] = segmentierung[1].evaluateFormel(false,t+t_ZERO,BASENUMBER,FACTOR,instrument[1].getMidimin(),instrument[1].getMidimax(),instrument[1]);
            //MIDI[2] = segmentierung[2].evaluateFormel(false,t+t_ZERO,BASENUMBER,FACTOR,instrument[2].getMidimin(),instrument[2].getMidimax(),instrument[2]);
            if(socket && socket!=null && MIDI)
                socket.send(MIDI[0]+":"+MIDI[1]);

//            if(MIDI[0]>0) instrument[0].play(MIDI[0],1.0);
//            if(MIDI[1]>0) instrument[1].play(MIDI[1],1.0);
//            if(MIDI[2]>0) instrument[2].play(MIDI[2],1.0);

            t++;
            tick++;

            var DIFF = pause_ms - (Date.now() - ZEIT);
            if(DIFF<0) DIFF=0;
            window.setTimeout(run, DIFF);
    }
    this.run = function() {run();}

}
